# GstParamSpec

GParamSpec implementations specific to GStreamer.

## GstParamArray

    GParamSpec
        ╰──GstParamArray

A fundamental type that describes a GParamSpec for arrays of values

Since : 1.12

## Gst.ParamArray

    GObject.ParamSpec
        ╰──Gst.ParamArray

A fundamental type that describes a GObject.ParamSpec for arrays of values

Since : 1.12

## Gst.ParamArray

    GObject.ParamSpec
        ╰──Gst.ParamArray

A fundamental type that describes a GObject.ParamSpec for arrays of values

Since : 1.12

## GstParamFraction

    GParamSpec
        ╰──GstParamFraction

A fundamental type that describes a GParamSpec for fractional properties

## Gst.ParamFraction

    GObject.ParamSpec
        ╰──Gst.ParamFraction

A fundamental type that describes a GObject.ParamSpec for fractional properties

## Gst.ParamFraction

    GObject.ParamSpec
        ╰──Gst.ParamFraction

A fundamental type that describes a GObject.ParamSpec for fractional properties

## GstParamSpecArray

A GParamSpec derived structure for arrays of values.

### Members

`parent_instance` (GParamSpec) –

super class

`element_spec` (GParamSpec *) –

the GParamSpec of the type of values in the array

## Gst.ParamSpecArray

A GParamSpec derived structure for arrays of values.

### Members

`parent_instance` (GObject.ParamSpec) –

super class

`element_spec` (GObject.ParamSpec) –

the GObject.ParamSpec of the type of values in the array

## Gst.ParamSpecArray

A GParamSpec derived structure for arrays of values.

### Members

`parent_instance` (GObject.ParamSpec) –

super class

`element_spec` (GObject.ParamSpec) –

the GObject.ParamSpec of the type of values in the array

## GstParamSpecFraction

A GParamSpec derived structure that contains the meta data for fractional properties.

### Members

`parent_instance` (GParamSpec) –

super class

`min_num` (gint) –

minimal numerator

`min_den` (gint) –

minimal denominator

`max_num` (gint) –

maximal numerator

`max_den` (gint) –

maximal denominator

`def_num` (gint) –

default numerator

`def_den` (gint) –

default denominator

## Gst.ParamSpecFraction

A GParamSpec derived structure that contains the meta data for fractional properties.

### Members

`parent_instance` (GObject.ParamSpec) –

super class

`min_num` (Number) –

minimal numerator

`min_den` (Number) –

minimal denominator

`max_num` (Number) –

maximal numerator

`max_den` (Number) –

maximal denominator

`def_num` (Number) –

default numerator

`def_den` (Number) –

default denominator

## Gst.ParamSpecFraction

A GParamSpec derived structure that contains the meta data for fractional properties.

### Members

`parent_instance` (GObject.ParamSpec) –

super class

`min_num` (int) –

minimal numerator

`min_den` (int) –

minimal denominator

`max_num` (int) –

maximal numerator

`max_den` (int) –

maximal denominator

`def_num` (int) –

default numerator

`def_den` (int) –

default denominator

## Functions

### gst_param_spec_array

    GParamSpec *
    gst_param_spec_array (const gchar * name,
                          const gchar * nick,
                          const gchar * blurb,
                          GParamSpec * element_spec,
                          GParamFlags flags)

This function creates a GstArray GParamSpec for use by objects/elements that want to expose properties of GstArray type. This function is typically * used in connection with g_object_class_install_property in a GObjects's instance_init function.

Parameters:

`name` –

canonical name of the property specified

`nick` –

nick name for the property specified

`blurb` –

description of the property specified

`element_spec` –

GParamSpec of the array

`flags` –

flags for the property specified

Returns ( [transfer: full]) –

a newly created parameter specification

Since : 1.14

### Gst.prototype.param_spec_array

    function Gst.prototype.param_spec_array(name: String, nick: String, blurb: String, element_spec: GObject.ParamSpec, flags: GObject.ParamFlags): {
        // javascript wrapper for 'gst_param_spec_array'
    }

This function creates a GstArray GParamSpec for use by objects/elements that want to expose properties of GstArray type. This function is typically * used in connection with GObject.ObjectClass.prototype.install_property in a GObjects's instance_init function.

Parameters:

`name` (String) –

canonical name of the property specified

`nick` (String) –

nick name for the property specified

`blurb` (String) –

description of the property specified

`element_spec` (GObject.ParamSpec) –

GParamSpec of the array

`flags` (GObject.ParamFlags) –

flags for the property specified

Returns (GObject.ParamSpec) –

a newly created parameter specification

Since : 1.14

### Gst.param_spec_array

    def Gst.param_spec_array (name, nick, blurb, element_spec, flags):
        #python wrapper for 'gst_param_spec_array'

This function creates a GstArray GParamSpec for use by objects/elements that want to expose properties of GstArray type. This function is typically * used in connection with GObject.ObjectClass.install_property in a GObjects's instance_init function.

Parameters:

`name` (str) –

canonical name of the property specified

`nick` (str) –

nick name for the property specified

`blurb` (str) –

description of the property specified

`element_spec` (GObject.ParamSpec) –

GParamSpec of the array

`flags` (GObject.ParamFlags) –

flags for the property specified

Returns (GObject.ParamSpec) –

a newly created parameter specification

Since : 1.14

### gst_param_spec_fraction

    GParamSpec *
    gst_param_spec_fraction (const gchar * name,
                             const gchar * nick,
                             const gchar * blurb,
                             gint min_num,
                             gint min_denom,
                             gint max_num,
                             gint max_denom,
                             gint default_num,
                             gint default_denom,
                             GParamFlags flags)

This function creates a fraction GParamSpec for use by objects/elements that want to expose properties of fraction type. This function is typically used in connection with g_object_class_install_property in a GObjects's instance_init function.

Parameters:

`name` –

canonical name of the property specified

`nick` –

nick name for the property specified

`blurb` –

description of the property specified

`min_num` –

minimum value (fraction numerator)

`min_denom` –

minimum value (fraction denominator)

`max_num` –

maximum value (fraction numerator)

`max_denom` –

maximum value (fraction denominator)

`default_num` –

default value (fraction numerator)

`default_denom` –

default value (fraction denominator)

`flags` –

flags for the property specified

Returns ( [transfer: full][nullable]) –

a newly created parameter specification

### Gst.prototype.param_spec_fraction

    function Gst.prototype.param_spec_fraction(name: String, nick: String, blurb: String, min_num: Number, min_denom: Number, max_num: Number, max_denom: Number, default_num: Number, default_denom: Number, flags: GObject.ParamFlags): {
        // javascript wrapper for 'gst_param_spec_fraction'
    }

This function creates a fraction GParamSpec for use by objects/elements that want to expose properties of fraction type. This function is typically used in connection with GObject.ObjectClass.prototype.install_property in a GObjects's instance_init function.

Parameters:

`name` (String) –

canonical name of the property specified

`nick` (String) –

nick name for the property specified

`blurb` (String) –

description of the property specified

`min_num` (Number) –

minimum value (fraction numerator)

`min_denom` (Number) –

minimum value (fraction denominator)

`max_num` (Number) –

maximum value (fraction numerator)

`max_denom` (Number) –

maximum value (fraction denominator)

`default_num` (Number) –

default value (fraction numerator)

`default_denom` (Number) –

default value (fraction denominator)

`flags` (GObject.ParamFlags) –

flags for the property specified

Returns (GObject.ParamSpec) –

a newly created parameter specification

### Gst.param_spec_fraction

    def Gst.param_spec_fraction (name, nick, blurb, min_num, min_denom, max_num, max_denom, default_num, default_denom, flags):
        #python wrapper for 'gst_param_spec_fraction'

This function creates a fraction GParamSpec for use by objects/elements that want to expose properties of fraction type. This function is typically used in connection with GObject.ObjectClass.install_property in a GObjects's instance_init function.

Parameters:

`name` (str) –

canonical name of the property specified

`nick` (str) –

nick name for the property specified

`blurb` (str) –

description of the property specified

`min_num` (int) –

minimum value (fraction numerator)

`min_denom` (int) –

minimum value (fraction denominator)

`max_num` (int) –

maximum value (fraction numerator)

`max_denom` (int) –

maximum value (fraction denominator)

`default_num` (int) –

default value (fraction numerator)

`default_denom` (int) –

default value (fraction denominator)

`flags` (GObject.ParamFlags) –

flags for the property specified

Returns (GObject.ParamSpec) –

a newly created parameter specification

## Function Macros

### GST_IS_PARAM_SPEC_ARRAY_LIST

    #define GST_IS_PARAM_SPEC_ARRAY_LIST(pspec) (G_TYPE_CHECK_INSTANCE_TYPE ((pspec), GST_TYPE_PARAM_ARRAY_LIST))

### GST_PARAM_SPEC_ARRAY_LIST

    #define GST_PARAM_SPEC_ARRAY_LIST(pspec)    (G_TYPE_CHECK_INSTANCE_CAST ((pspec), GST_TYPE_PARAM_ARRAY_LIST, GstParamSpecArray))

## Constants

### GST_PARAM_CONDITIONALLY_AVAILABLE

    #define GST_PARAM_CONDITIONALLY_AVAILABLE  (1 << (G_PARAM_USER_SHIFT + 6))

Use this flag on GObject properties of GstObject to indicate that they might not be available depending on environment such as OS, device, etc, so such properties will be installed conditionally only if the GstObject is able to support it.

Since : 1.18

### Gst.PARAM_CONDITIONALLY_AVAILABLE

Use this flag on GObject properties of GstObject to indicate that they might not be available depending on environment such as OS, device, etc, so such properties will be installed conditionally only if the GstObject is able to support it.

Since : 1.18

### Gst.PARAM_CONDITIONALLY_AVAILABLE

Use this flag on GObject properties of GstObject to indicate that they might not be available depending on environment such as OS, device, etc, so such properties will be installed conditionally only if the GstObject is able to support it.

Since : 1.18

### GST_PARAM_CONTROLLABLE

    #define GST_PARAM_CONTROLLABLE	(1 << (G_PARAM_USER_SHIFT + 1))

Use this flag on GObject properties to signal they can make sense to be. controlled over time. This hint is used by the GstController.

### Gst.PARAM_CONTROLLABLE

Use this flag on GObject properties to signal they can make sense to be. controlled over time. This hint is used by the GstController.

### Gst.PARAM_CONTROLLABLE

Use this flag on GObject properties to signal they can make sense to be. controlled over time. This hint is used by the GstController.

### GST_PARAM_DOC_SHOW_DEFAULT

    #define GST_PARAM_DOC_SHOW_DEFAULT  (1 << (G_PARAM_USER_SHIFT + 5))

Use this flag on GObject properties of GstObject to indicate that during `gst-inspect` and friends, the default value should be used as default instead of the current value.

Since : 1.18

### Gst.PARAM_DOC_SHOW_DEFAULT

Use this flag on GObject properties of GstObject to indicate that during `gst-inspect` and friends, the default value should be used as default instead of the current value.

Since : 1.18

### Gst.PARAM_DOC_SHOW_DEFAULT

Use this flag on GObject properties of GstObject to indicate that during `gst-inspect` and friends, the default value should be used as default instead of the current value.

Since : 1.18

### GST_PARAM_MUTABLE_PAUSED

    #define GST_PARAM_MUTABLE_PAUSED  (1 << (G_PARAM_USER_SHIFT + 3))

Use this flag on GObject properties of GstElements to indicate that they can be changed when the element is in the PAUSED or lower state. This flag implies GST_PARAM_MUTABLE_READY.

### Gst.PARAM_MUTABLE_PAUSED

Use this flag on GObject properties of GstElements to indicate that they can be changed when the element is in the PAUSED or lower state. This flag implies GST_PARAM_MUTABLE_READY.

### Gst.PARAM_MUTABLE_PAUSED

Use this flag on GObject properties of GstElements to indicate that they can be changed when the element is in the PAUSED or lower state. This flag implies GST_PARAM_MUTABLE_READY.

### GST_PARAM_MUTABLE_PLAYING

    #define GST_PARAM_MUTABLE_PLAYING  (1 << (G_PARAM_USER_SHIFT + 4))

Use this flag on GObject properties of GstElements to indicate that they can be changed when the element is in the PLAYING or lower state. This flag implies GST_PARAM_MUTABLE_PAUSED.

### Gst.PARAM_MUTABLE_PLAYING

Use this flag on GObject properties of GstElements to indicate that they can be changed when the element is in the PLAYING or lower state. This flag implies GST_PARAM_MUTABLE_PAUSED.

### Gst.PARAM_MUTABLE_PLAYING

Use this flag on GObject properties of GstElements to indicate that they can be changed when the element is in the PLAYING or lower state. This flag implies GST_PARAM_MUTABLE_PAUSED.

### GST_PARAM_MUTABLE_READY

    #define GST_PARAM_MUTABLE_READY  (1 << (G_PARAM_USER_SHIFT + 2))

Use this flag on GObject properties of GstElements to indicate that they can be changed when the element is in the READY or lower state.

### Gst.PARAM_MUTABLE_READY

Use this flag on GObject properties of GstElements to indicate that they can be changed when the element is in the READY or lower state.

### Gst.PARAM_MUTABLE_READY

Use this flag on GObject properties of GstElements to indicate that they can be changed when the element is in the READY or lower state.

### GST_PARAM_USER_SHIFT

    #define GST_PARAM_USER_SHIFT	(1 << (G_PARAM_USER_SHIFT + 8))

Bits based on GST_PARAM_USER_SHIFT can be used by 3rd party applications.

### Gst.PARAM_USER_SHIFT

Bits based on GST_PARAM_USER_SHIFT can be used by 3rd party applications.

### Gst.PARAM_USER_SHIFT

Bits based on GST_PARAM_USER_SHIFT can be used by 3rd party applications.

### GST_TYPE_PARAM_ARRAY_LIST

    #define GST_TYPE_PARAM_ARRAY_LIST           (gst_param_spec_array_get_type ())

### GST_TYPE_PARAM_FRACTION

    #define GST_TYPE_PARAM_FRACTION           (gst_param_spec_fraction_get_type ())

The results of the search are